<template>
  <div class="modal-container" v-if="isOpenModal" @click.stop="toggleModal">
    <div class="relative w-auto my-6 mx-auto max-w-6xl">
      <form
        @submit.prevent="saveEditData"
        id="save-user"
        class="form-container"
      >
        <div
          class="flex items-start justify-between p-6 border-b border-purple-200 border-solidrounded-t"
        >
          <h3 class="text-2xl text-purple-700 font-semibold">
            Edit Internship
          </h3>
        </div>
        <div
          class="w-full p-6 sm:bg-white overflow-hidden flex flex-row flex-no-wrap"
        >
          <div
            class="relative flex-col w-full grid grid-cols-2 gap-4"
            id="edit-container"
          >
            <input v-model="editedUser.name" type="text" required />
            <input v-model="editedUser.email" type="email" required />
            <input v-model="editedUser.telephone" type="tel" required />
            <input v-model="editedUser.university" type="text" required />
            <select v-model="editedUser.office" required>
              <option>BH</option>
              <option>SP</option>
            </select>
            <input v-model="editedUser.date" type="date" />
          </div>
        </div>
        <div
          class="flex items-center justify-end p-6 border-t border-solid border-purple-200 rounded-b"
        >
          <button
            id="close-edit"
            class="text-red-500 border-red-500 hover:bg-red-500"
            @click.stop="toggleModal"
          >
            Close
          </button>
          <button
            class="text-green-500 border-green-500 hover:bg-green-500"
            type="submit"
          >
            Save
          </button>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
export default {
  name: "EditUserModal",
  props: {
    editedUser: Object,
  },
  computed: {
    isOpenModal() {
      return this.$store.getters["users/getModalState"];
    },
  },
  methods: {
    toggleModal(e) {
      if (e.currentTarget !== e.target) return;

      this.$store.dispatch("users/toggleModal");
    },
    saveEditData(e) {
      this.$store.dispatch("users/updateUser", this.editedUser);
      this.toggleModal(e);
      this.editedUser.id = "";
      this.editedUser.name = "";
      this.editedUser.email = "";
      this.editedUser.telephone = "";
      this.editedUser.university = "";
      this.editedUser.office = "";
      this.editedUser.date = "";
    },
  },
};
</script>

<style scoped>
[type="text"],
[type="email"],
[type="url"],
[type="date"],
[type="tel"],
[multiple],
textarea,
select {
  @apply rounded-md border-purple-700 border shadow-sm focus:border-purple-800 focus:ring focus:ring-purple-800 focus:ring-opacity-50;
}
button {
  @apply bg-transparent border border-solid hover:text-white font-bold uppercase text-sm px-6 py-3 rounded outline-none focus:outline-none mr-1 mb-1 ease-linear transition-all duration-150;
}
.modal-container {
  @apply overflow-x-hidden overflow-y-auto fixed inset-0 z-50 outline-none focus:outline-none justify-center items-center flex;
}
.form-container {
  @apply border-0 rounded-lg shadow-lg relative flex flex-col w-full bg-white outline-none focus:outline-none;
}
</style>

 
